'use strict';

var shim = require('use-sync-external-store/shim');

//
// In order to avoid removing and re-adding subscriptions each time this hook is called,
// the parameters passed to this hook should be memoized in some way–
// either by wrapping the entire params object with useMemo()
// or by wrapping the individual callbacks with useCallback().

function useSubscription(_ref) {
  var getCurrentValue = _ref.getCurrentValue,
      subscribe = _ref.subscribe;
  return shim.useSyncExternalStore(subscribe, getCurrentValue);
}

exports.useSubscription = useSubscription;
//# sourceMappingURL=use-subscription.development.js.map
